com.saxonica.stream.watch

## Class ApplyTemplatesWatch

- java.lang.Object
- - com.saxonica.validate.AbstractWatch
  - - com.saxonica.stream.watch.EventPushingWatch
    - - com.saxonica.stream.watch.ApplyTemplatesWatch

- All Implemented Interfaces:
    Watch
  Direct Known Subclasses:
    ApplyImportsWatch, NextMatchWatch

      public class ApplyTemplatesWatch
      extends EventPushingWatch

  This watch implements xsl:apply-templates in streaming mode. It watches for the nodes selected by the xsl:apply-templates instruction; when such a node is encountered, it locates the relevant (inverted) template, and activates it. The watch is capable of handling a select expression that selects non-peer nodes (that is, one selected node that is a descendant of another). A top-level selected node is processed directly to the output receiver; a nested node is processed to create a temporary result tree, which is then appended to the output sequence when the processing of the outer selected node is complete.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ApplyTemplatesWatch(Expression expression, SequenceReceiver result, Stack<XPathContext> contextStack)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` The close() method is called immediately before the Watch is destroyed, that is, when the element whose declaration scopes the constraint implemented by this Watch goes out of scope.
    `void` | `computeActualParams(WithParam[] params)`
    `void` | `computeTunnelParams(WithParam[] params)`
    `void` | `endSelectedParentNode(int locationId)` Signal that the endElement event has occurred for the element whose startElement event caused the Watch to be activated.
    `protected XPathContext` | `getLocalContext()`
    `Mode` | `getMode()`
    `protected Rule` | `getRule(FleetingNode node)` Get the template rule matching a specific node
    `void` | `notifySelectedLeafNode(FleetingNode node, int locationId)` Signal that a node (other than an element) that matches the selection has been found.
    `void` | `open()` Open the watch.
    `void` | `setActualParams(ParameterSet params)`
    `void` | `setMode(Mode mode)`
    `void` | `setTunnelParams(ParameterSet params)`
    `void` | `setWatchManager(WatchManager watchManager)`
    `Receiver` | `startSelectedParentNode(FleetingNode node, int locationId)` Signal that an element or document node has been found that matches the selection that this Watch is looking for.

    - ### Methods inherited from class com.saxonica.stream.watch.EventPushingWatch

      `getContext, getContextStack, getExpression, getParentExpressionFeed, getResult, setParentExpressionFeed`

    - ### Methods inherited from class com.saxonica.validate.AbstractWatch

      `getAnchorNode, getNamespaceResolver, getPipelineConfiguration, getSelection, setAnchorNode, setNamespaceResolver, setPipelineConfiguration, setSelection`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ApplyTemplatesWatch

          public ApplyTemplatesWatch(Expression expression,
                             SequenceReceiver result,
                             Stack<XPathContext> contextStack)

  - ### Method Detail

    - #### open

          public void open()
                    throws XPathException

      Description copied from class: `AbstractWatch`
      Open the watch. This is done at the point where it first starts watching for nodes that match the selection.
      Specified by:
        `open` in interface `Watch`
      Overrides:
        `open` in class `EventPushingWatch`
      Throws:
        `XPathException`

    - #### computeActualParams

          public void computeActualParams(WithParam[] params)
                                   throws XPathException

      Throws:
        `XPathException`

    - #### computeTunnelParams

          public void computeTunnelParams(WithParam[] params)
                                   throws XPathException

      Throws:
        `XPathException`

    - #### setActualParams

          public void setActualParams(ParameterSet params)
                               throws XPathException

      Throws:
        `XPathException`

    - #### setTunnelParams

          public void setTunnelParams(ParameterSet params)
                               throws XPathException

      Throws:
        `XPathException`

    - #### getLocalContext

          protected XPathContext getLocalContext()

    - #### setMode

          public void setMode(Mode mode)

    - #### getMode

          public Mode getMode()

    - #### setWatchManager

          public void setWatchManager(WatchManager watchManager)

    - #### startSelectedParentNode

          public Receiver startSelectedParentNode(FleetingNode node,
                                         int locationId)
                                           throws XPathException

      Signal that an element or document node has been found that matches the selection that this Watch is looking for. This method is called by the WatchManager while processing the startElement or startDocument event that matches the selection.
      Parameters:
        `node` - the element or document node whose start event has been matched
        `locationId` - the location associated with the element or document node (may be the location of the instruction that created it)
      Returns:
        a Receiver to be notified of all events starting with the startElement/startDocument event for the matched element, and ending with the endElement event for that element; or null if this feature is not required.
      Throws:
        `XPathException` - May be raised if a dynamic error occurs

    - #### getRule

          protected Rule getRule(FleetingNode node)
                          throws XPathException

      Get the template rule matching a specific node
      Parameters:
        `node` - the node (in a streamed input document) to be matched
      Returns:
        the best-fit template rule used to process this node
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### notifySelectedLeafNode

          public void notifySelectedLeafNode(FleetingNode node,
                                    int locationId)
                                      throws XPathException

      Signal that a node (other than an element) that matches the selection has been found.
      Specified by:
        `notifySelectedLeafNode` in interface `Watch`
      Overrides:
        `notifySelectedLeafNode` in class `AbstractWatch`
      Parameters:
        `node` - the node that was matched.
        `locationId` - the location of the node in the source document
      Throws:
        `XPathException`

    - #### endSelectedParentNode

          public void endSelectedParentNode(int locationId)
                                     throws XPathException

      Signal that the endElement event has occurred for the element whose startElement event caused the Watch to be activated.
      Parameters:
        `locationId` - the location of the element
      Throws:
        `ValidationException` - May be raised if the constraint implemented by this Watch is violated @param locationId
        `XPathException` - May be raised if a constraint implemented by this Watch is violated

    - #### close

          public void close()
                     throws XPathException

      Description copied from class: `AbstractWatch`
      The close() method is called immediately before the Watch is destroyed, that is, when the element whose declaration scopes the constraint implemented by this Watch goes out of scope. The default implementation does nothing.
      Specified by:
        `close` in interface `Watch`
      Overrides:
        `close` in class `EventPushingWatch`
      Throws:
        `XPathException`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.